/*
 * CartView.java
 *
 * Created on 10 de agosto de 2004, 18:01
 */

package com.fenalco.servlets.shopkeeper;

import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import com.fenalco.entities.ShoppingCart;
import com.fenalco.entities.User;
import com.fenalco.utilities.MessageBuilder;
import com.fenalco.utilities.lists.ShoppingCartView;

/**
 * Este servlet carga la información de los productos que el usuario tiene en el
 * carrito de compras y le pasa la lista al jsp para que la pinte
 * 
 * @author Mario Linares Vásquez
 *  
 */
public class CartView extends HttpServlet
{

	/**
	 * Inicializa the servlet.
	 * 
	 * @param config
	 * @throws ServletException
	 */
	public void init( ServletConfig config ) throws ServletException
	{
		super.init(config);

	}

	/**
	 * Destructor del servlet.
	 */
	public void destroy( )
	{

	}

	/**
	 * Obtiene de la sesión el carrito de compras y construye los objetos de
	 * tipo producto (clase <CODE>Product</CODE>), los adiciona a un vector y
	 * mete ese vector al <CODE>response</CODE> como un atributo con nombre
	 * <CODE>productsList</CODE>
	 * 
	 * luego redirecciona a /minorista/micarrito.jsp
	 * 
	 * @param request
	 *            servlet request
	 * @param response
	 *            servlet response
	 * @throws ServletException
	 * @throws IOException
	 */
	protected void processRequest( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		HttpSession session = request.getSession(false);
		String url = "";
		String message = "";

	    try
	    {
	        
	        if( session == null || ( User )session.getAttribute( "user" ) == null || ( ( User )session.getAttribute( "user" ) ).getRoleId() != 3 )
			{
				url = "/index.jsp";
				message = MessageBuilder.buildMessage(15);
			}
			else
			{
				ShoppingCart cart = (ShoppingCart) session.getAttribute("cart");
				if( cart == null )
				{
					cart = new ShoppingCart();
					session.setAttribute("cart", cart);
//					message = "Aún no ha puesto ningún producto en el carrito.";
				}
	
				ShoppingCartView cartView = new ShoppingCartView(cart);
				request.setAttribute("cartView", cartView);
	
				url = "/minorista/micarrito.jsp";
			}
	    }
	    catch( Exception e )
	    {
	        url="/logout";
	        message = MessageBuilder.buildMessage(15);
	    }
	        
        request.setAttribute( "message", message );
        RequestDispatcher rd = getServletContext().getRequestDispatcher( url );
        rd.forward(request, response);

	}
	    

	/**
	 * Procesa el método HTTP <code>GET</code>.
	 * 
	 * @param request
	 *            servlet request
	 * @param response
	 *            servlet response
	 * @throws ServletException
	 * @throws IOException
	 */
	protected void doGet( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Procesa el método HTTP <code>POST</code>.
	 * 
	 * @param request
	 *            servlet request
	 * @param response
	 *            servlet response
	 * @throws ServletException
	 * @throws IOException
	 */
	protected void doPost( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Retorna una breve descripción de el servlet.
	 * 
	 * @return
	 */
	public String getServletInfo( )
	{
		return "Short description";
	}

}